package Elementos;
#Para interpretar archivos .ele
#usados por simusol
use Data::Dumper;
use GlobalesSimusol;
use TraAbrev;
use Ayudas;
use Algebraico;
use Ampliaciones;
use Controles;
use Sceptre;
use Tablasfuncq;
use strict;
use warnings;
our $codelems  = '[JECRLT]';

BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&tratar_refvalores_USO_DEF
                &definir_UNIDADES
               )
 };


# ----------------------------------------------------------------------------
sub tratar_refvalores_USO_DEF{
  $avisosgrav = 0;
  comfin('com tratar_refvalores_USO_DEF', @_);
  my ($ilayer,$CORTO) = @_;
  my $reflay = $reflayer[$ilayer];
  my (%bueno, @malos);
  my @solovalores 
    = ('USO_DEF', 'FUNCIONES', 'TABLAS', 'TABLAS_ARCHIVOS', 'UNIDADES');
  map($bueno{$_} = 1, @solovalores); 
  my @keys = keys %{$reflay->{refvalores}};
  map(do {push @malos, $_ unless $bueno{$_}}, keys %{$reflay->{refvalores}});
  @malos and 
  do {porparar1(60, $reflay,
          "Los diagramas que definen elementos no deben tener cuadros
          @malos");
          return 60;
  };   
  my $coderr = '';
  $reflay->{refcirc}->{clasearch} = 'elementos';
  $coderr = definir_dibu($reflay);
  not $coderr and $coderr = definir_texto($reflay);
  not $coderr and $coderr = asignar_defiele($reflay);
  not $coderr and $coderr = asignar_ele($reflay);
  return $coderr if $coderr;
  comfin('fin tratar_refvalores_USO_DEF');
  return '';
}  #tratar_refvalores_USO_DEF
# ----------------------------------------------------------------------------
sub definir_UNIDADES{
  comfin('com definir_UNIDADES', @_);
  my $refcirc = $_[0];
  my %todos = %{$refcirc->{refvalores}->{UNIDADES}};
  #impr_debug(__LINE__.' Elem ',Dumper \%todos);
  my (%nombresnums,%numsnombres);
  my $numsplantilla;
  my $refun = $refcirc->{defiuni} = {};
  foreach my $numobj (keys %todos) {
      my $cuadro = descripcion_cuadro($numobj);
      #impr_debug(__LINE__.' Elem %todos', Dumper \%todos);
      my @renglones  = @{$todos{$numobj}};
      #impr_debug(__LINE__.' Elem @renglones',Dumper \@renglones);
      my @conplantilla = grep(/plantilla[\s=]+(\w.+)/i, @renglones);
      if (@conplantilla == 0) {
          my $ref = $refcirc->{lisobjconectsnonodos};
          if (defined $ref) {
              my @lista = @$ref;
              map ($_ = $plantillalista->[$_],@lista);
              @lista = union_conjunto(@lista);
              my @listanombres;
              foreach (@lista) {
                  push @listanombres, $nombreplantilla->[$_];
              };
              my $stringnombres = join ',',@listanombres; 
              @conplantilla = @listanombres;
              unshift @renglones, "PLANTILLA = $stringnombres";
          explic("Como no hay un renglón \"Plantilla = ..\" supondremos 
          que se refiere a las plantillas presentes en el diagrama; 
          como si se hubiera usado \"$stringnombres\"");
          } else {
              porparar1(111,$refcirc
               ,"Cuadro UNIDADES en $cuadro sin información utilizable
                ya que no hay renglon PLANTILLA  = ... 
                ni parte gráfica con íconos de alguna plantilla"); 
              return 111;
          };
      };
      #impr_debug(__LINE__.' Elem @renglones',Dumper \@renglones);
      #aqui ya tienen nombre de plantilla 
         if ($renglones[0] !~ /PLANTILLA/i) {
              porparar1(110,$refcirc,"Cambie $cuadro
              Si usa renglones \"plantilla = ...\",
                 debe aparecer uno en el primer renglón, 
                 (afectará a los renglones siguientes)");
	      return 110; 
              foreach my $prim (@conplantilla) {
                  $prim =~ /plantilla[\s=]+(\w.+)/i; 
                  my $texto = $1; $texto =~ s/\s*//g;
	          #impr_debug(__LINE__.' Elem plantilla ',[$texto]);
                  my @lista = split /\s*,\s*/, $texto;
                  foreach             (@lista) {
                      my $plantilla = $cualplantilla->{$_};
                      not defined $plantilla 
                         and $plantilla = aumentar_plantilla($_);
                      $_ = $plantilla; 
                  };
                  $numsplantilla = join ',',@lista;
                  $nombresnums{$numsplantilla} = $texto;
                  $numsnombres{$texto} = $numsplantilla; 
              };
	  };
      #impr_debug(__LINE__.' Elem @renglones',Dumper \@renglones);
      my  $texto = ''; my $refunis;
      while (@renglones) {        
          $_ = shift @renglones;
          if (s/plantilla\s*[=\s\:]\s*(\w)/$1/i) {
              my @lista = split /\s*,\s*/;
              map ($_ = uc(substr($_,0,1)) . lc(substr($_,1)), @lista);
              $texto = join ',', @lista;
	      #impr_debug(__LINE__.' Elem $texto', $texto);
              defined $refun->{$texto} or 
              do{ $refun->{$texto}->{defis} = {};
                  $refun->{$texto}->{eles} = [];
                  $refun->{$texto}->{archivouni}
                    = $refcirc->{archivo}; 
              };
              $refunis = $refun->{$texto}->{defis}; 
	  } elsif (my ($ele, $valor) =  (/^\s*([CEJLMR])\s*\:\s*(.+)/i)) {
              $ele = uc($ele);
              my $cuantascomas = ($valor =~ tr/\,//);
              $ele =~ /[CLMR]/ and $cuantascomas == 1 or
              $ele =~ /[EJ]/ and $cuantascomas =~ /[12]/  or
              do {porparar1(112, $refcirc
                  ,"Definición incorrecta de unidades para
                      $ele : $valor
                  Debe indicar unidad y nombre de magnitud;\n en $cuadro");
                  return 112;
              };
              $ele =~ /[EJ]/ and $cuantascomas == 1 and
              do {my $abr = 'TEMP';
                  $abr = 'FLUJO' if $ele eq 'J';
                  $valor .= ",$abr";
                  avnograv( 
                   "Puede agregar abreviatura para $ele; por ejemplo,
                     puede escribir: $ele : $valor;\n en $cuadro");
              };
              $refunis->{$ele} = $valor; 
              push @{$refun->{$texto}->{eles}}, $ele; 
           } else {
               porparar1(113,$refcirc,
               "No se entiende 
                  $_ 
                sólo se entienden renglones como:
                  Plantilla = Termico
                  R : gradoC/W, resistencia_termica
                  E : gradoC, temperatura,TEMP
                (primer símbolo puede ser: C E J  L R)");
               return 113;
	   };
      }; #while #renglones
      foreach my $texto (keys %$refun) {
          scalar keys %$refunis or 
          do {porparar1(114,$refcirc,"No hay definiciones en $cuadro");
              return 114;
          };      
          scalar @{$refun->{$texto}->{eles}} 
             != scalar union_conjunto(@{$refun->{$texto}->{eles}}) and
          do {porparar1(115,$refcirc,"Hay redefiniciones  en $cuadro");
              return 115;
          }; 
	  #impr_debug(__LINE__.' Elem $refun->{$texto}', "$texto "
          #       . Dumper $refun->{$texto});
          scalar @{$refun->{$texto}->{eles}} 
           != scalar (union_conjunto(@{$refun->{$texto}->{eles}},'E','J')) and 
          do {porparar1(116,$refcirc,"Faltan definiciones para E y/o para J
              en $cuadro"); return 116
          }; 
      }; #foreach my $texto
  }; #foreach $numobj
  asignar_unidades($refcirc);
  #impr_debug(__LINE__.' Elem $DEFIUNI', Dumper $DEFIUNI);
  comfin('fin definir_UNIDADES');
  return 0;
}
# ----------------------------------------------------------------------------
sub asignar_unidades{
  comfin('com asignar_unidades',@_);
  my $refcirc = $_[0];
  my @listatextos = keys %{$refcirc->{defiuni}}; 
  my $coderr = ''; 
  $palabrasequivV = {}; $palabrasequivI = {};
  #impr_debug(__LINE__.' Elem defiuni', Dumper $refcirc->{defiuni});
  foreach my $texto (@listatextos) {
      my $refunis = $refcirc->{defiuni}->{$texto}->{defis};
      my ($defiu, $defic, $defim, $defia, $defie);
      foreach my $ele (keys %{$refunis}) {
          my $valor = $refunis->{$ele};
          my @listita = split /\s*\,\s*/, $valor;
          $defiu->{$ele} = $listita[0];
          $defic->{$ele} = "$listita[1],$listita[0]";     
          $defim->{$ele} = $listita[1];
          if ($ele =~ /[EJ]/) {
             $defia->{$ele} = $listita[2];
             if ($ele eq 'E') {
                 $defie->{$ele} = 'V';
	     } else {
                 $defie ->{$ele} = 'I';
             };
             $defie->{$defia->{$ele}} = $defie->{$ele};
             
	  };
      };
      $defie->{V} = 'V'; $defie->{I} = 'I'; 
      my @listaplant = split /\s*\,\s*/,$texto;
      foreach (@listaplant) {
          $_ = $cualplantilla->{$_};
          next unless defined $_;
          if( defined $DEFIUNI->{$_}) {
          } else {
	      %{$DEFIUNI->{$_}->{defis}} = %$refunis; 
              $DEFIUNI->{$_}->{archivouni} 
		= $refcirc->{defiuni}->{$texto}->{archivouni};
              %{$defiuni->{$_}} = %$defiu;
              %{$deficomp->{$_}} = %$defic;
              %{$defimagn->{$_}} = %$defim;
              %{$defiabrev->{$_}} = %$defia;
              %{$defiequiv->{$texto}} = %$defie;
              push @{$palabrasequivV->{$defia->{E}}}, $_;
              push @{$palabrasequivI->{$defia->{J}}}, $_; 
          };
      };
  };
  $palabrasequivV->{V} = [];
  $palabrasequivI->{I} = [];
  #impr_debug(__LINE__.' Elem $DEFIUNI ',Dumper $DEFIUNI);
  #impr_debug(__LINE__.' Elem $deficomp ',Dumper $deficomp);
  #impr_debug(__LINE__.' Elem $defimagn ',Dumper $defimagn);
  #impr_debug(__LINE__.' Elem $defiabrev ',Dumper $defiabrev);
  #impr_debug(__LINE__.' Elem $defiequiv ',Dumper $defiequiv);
  #impr_debug(__LINE__.' Elem $palabrasequivV ',Dumper $palabrasequivV);
  #impr_debug(__LINE__.' Elem $palabrasequivI ',Dumper $palabrasequivI);
  comfin('fin asignar_unidades');
} # asignar_unidades
# ----------------------------------------------------------------------------
sub definir_dibu{
# analiza la parte grafica del diagrama, guarda la informacion,
# luego de controlar lo controlable, en 
# $reflay->{defidibu} (key principal $texto)
  comfin('com definir_dibu',@_);
  my ($reflay) = @_;
  #impr_debug(__LINE__.' Elem $reflay', $reflay);
  my @listaobj = grep ($codlista->[$_]=~ /[CEJLRZ]/
                ,@{$reflay->{lisobjtodos}});
  my @nodosobj =  grep ($codlista->[$_] eq 'N',@{$reflay->{lisobjtodos}});
  #impr_debug(__LINE__.' Elem lisobjtodos', $reflay->{lisobjtodos});
  #impr_debug(__LINE__.' Elem @nodosobj', \@nodosobj);
  my ($datospcs,$datosclasepcs) = ({},{});
  foreach my $nodoobj (@nodosobj) {
      my @lista = @{$reflay->{unionesobj}->{$nodoobj}};
      @lista != 1 and
      do {porparar1(10,$reflay,"El nodo en $lugarlista->[$nodoobj] tiene "
          . scalar @lista . ' conexiones; debe tener sólo 1');
          return 10;
      };
  };
  @listaobj or
  do {porparar1(11,$reflay,"Falta la parte gráfica que acompañe los
      cuadros USO_DEF");
      return 11;
  };
  #impr_debug(__LINE__.' Elem @listaobj', \@listaobj);
  my $rdb = $reflay->{defidibu} = {};
  foreach my $obj (@listaobj) {
      my $texto = $textolista->[$obj];
      if ($texto eq '') {
          porparar1(12,$reflay
          ,"El ícono en $lugarlista->[$obj] no está identificado");
          return 12;
      } elsif ($texto eq '&') {
          $textolista->[$obj] = 0; # $texto sigue valiendo '&'
          #next;
      };
      defined $rdb->{$texto} or $rdb->{$texto} = {};
      my $rdbt = $rdb->{$texto};
      push @{$rdbt->{listaobjs}}, $obj;
      my $plantilla = $plantillalista->[$obj];
      push @{$rdbt->{plantilla}}, $plantilla;
      my $shape = $shapelista->[$obj];  
      my $pcs = $plantilla .'c'.$shape;
      push @{$rdbt->{listapcs}}, $pcs;
      my (@lisnodos,@listextonodos);
      if (defined $reflay->{unionesobj}->{$obj}) {
          @lisnodos = @{$reflay->{unionesobj}->{$obj}};
          @lisnodos and $texto eq '&' and
          do {porparar1(13,$reflay,"El ícono en $lugarlista->[$obj] solo sirve
              para \"tierra\"; no debe conectarse a ningún nodo");
             return 13;
          };
          foreach my $objnodo (@lisnodos) {
              my $textonodo = $textolista->[$objnodo];
              $textonodo ne '0' or 
              do {porparar1(14,$reflay,"no deben aparecer, en forma explicita, 
                  conexiones a nodos tierra como ocurre con el ícono en 
                  $lugarlista->[$obj]");
              return 14;
              };
              push @listextonodos, $textonodo;
          };
          scalar(union_conjunto(@listextonodos)) < @listextonodos and
          do {porparar1(15,$reflay,"nodos con identificación repetida para
              ícono  en: $lugarlista->[$obj]:  @listextonodos");
               return 15;
          };
          map ($rdbt->{esunnodo}->{$_} = 1,@listextonodos); 
          push @{$rdbt->{nodos}},join ('-', @listextonodos);
          push @{$datospcs->{$pcs}->{cuantosnodos}}, scalar @lisnodos;
      } else {
          $texto ne '&' and 
          do {porparar1(16,$reflay,"El ícono en $lugarlista->[$obj],
              identificado con $texto, no tiene conexiones");
              return 16;
          };
          push @{$rdbt->{nodos}},'';
          push @{$datospcs->{$pcs}->{cuantosnodos}}, 0;
      };
      push @{$datospcs->{$pcs}->{lugares}}
          , $lugarlista->[$obj];
  };
  foreach my $texto (keys %$rdb){
      my $rdbt = $rdb->{$texto};
      my @lispcs = sort(union_conjunto(@{$rdbt->{listapcs}}));
      my @lislugares = @{$rdbt->{listaobjs}};
      map (do{$_ = $lugarlista->[$_]; s/\s*$//}, @lislugares);
      $rdbt->{stringlugares} = join ' ',@lislugares;
      #impr_debug(__LINE__.' Elem @lispcs',\@lispcs);
      my $clasepcs = join ' ',@lispcs;
      map (do {push @{$datospcs->{$_}->{clasepcs}}, $clasepcs},@lispcs);
      $rdbt->{clasepcs} = $clasepcs;
      foreach my $palabra ('plantilla','nodos') {
           my @lista = @{$rdbt->{$palabra}}
              = union_conjunto(@{$rdbt->{$palabra}});
	  #impr_debug(__LINE__.' Elem @lista', \@lista);
	  #impr_debug(__LINE__.' Elem scalar @lista', scalar @lista);
          if (@lista != 1) { 
              if ($palabra eq 'plantilla') {
                  map ($_ = $nombreplantilla->[$_],@lista);
              };
              porparar1(18, $reflay
		 ,"Los íconos identificados con $texto, en lugares
                 $rdbt->{stringlugares} tienen diferentes \"$palabra\"
                 @lista");
              return 18;
          } else {
	      if ($palabra eq 'plantilla') {
                  push @{$datosclasepcs->{$clasepcs}->{plantilla}}
		  , $rdbt->{plantilla}->[0];
                  delete $rdbt->{plantilla};
              } else {
                  $rdbt->{nodos} = $rdbt->{nodos}->[0];
                  my $cuantosnodos = ($rdbt->{nodos} =~ tr/[\-]//) + 1;
                  push @{$datosclasepcs->{$clasepcs}->{cuantosnodos}}
			 , $cuantosnodos;
              };
          };
      };
  };
  if (defined $reflay->{defidibu}->{'&'}) {
       $reflay->{defidibu}->{0} = $reflay->{defidibu}->{'&'};
       delete $reflay->{defidibu}->{'&'};
       @{$reflay->{defidibu}->{'0'}->{listapcs}} >1 and
       do {avnograv("Hay más de un ícono previsto para tierra en
           lugares: $reflay->{defidibu}->{'0'}->{stringlugares};
           ¿está seguro de necesitarlos?")
       };
  };
  my $rde = $reflay->{defiele} = {};
  #impr_debug(__LINE__.' Elem datospcs', Dumper $datospcs);
  foreach my $pcs (keys %$datospcs) {
      my @lista; 
      @lista = @{$datospcs->{$pcs}->{clasepcs}}
          = union_conjunto(@{$datospcs->{$pcs}->{clasepcs}});
      #impr_debug(__LINE__.' Elem @lista', \@lista);
      #impr_debug(__LINE__.' Elem scalar @lista', scalar @lista);
      if (@lista != 1) { 
          my $lista = join "\n         ",\@lista;
          my $lug =" @{$datospcs->{$pcs}->{lugares}}"; 
          porparar1(66, $reflay ,"El ícono que aparece en lugares
              $lug 
              está agrupado en más de un modo:
              $lista");
             return 66;
          } else {
	      $rde->{datospcs}->{$pcs}->{clasepcs}
                = $datospcs->{$pcs}->{clasepcs} = $lista[0];
          };
  }
  foreach my $clasepcs (keys %$datosclasepcs ) {
      foreach my $palabra ('plantilla','cuantosnodos') {
          my @lista 
            = union_conjunto(@{$datosclasepcs->{$clasepcs}->{$palabra}}); 
          if (@lista != 1) {
              porparar1(66, $reflay,"La clase de íconos $clasepcs
              tiene valores diferentes para $palabra:
              @lista");
              return 66;
          };
          $rde->{datosclasepcs}->{$clasepcs}->{$palabra}
	  = $datosclasepcs->{$clasepcs}->{$palabra}->[0];
      }; 
  };
  #impr_debug(__LINE__.' Elem $rdb', Dumper $rdb);
  #impr_debug(__LINE__.' Elem datosclasepcs', Dumper $datosclasepcs);
  #impr_debug(__LINE__.' Elem $rde', Dumper $rde);
  comfin('fin  definir_dibu');
  return '';
}   
# ----------------------------------------------------------------------------
sub definir_texto{
  #analiza la parte de texto del diagrama
  # crea $reflay->{defitexto} con informacion exclusiva de cuadros
  #completa informacion para {defidibu}
  # y llena o pide llenar parcialmente $reflay->{defiele}
  # errores graves en una definicion marca el archivo como erroneo
  # no es error que haya nombres largos como argumentos; no llegan al Sceptre
  # solo mira contenido de cuadros
  comfin('com definir_texto', @_);
  my ($reflay) = @_;
  my $rdb = $reflay->{defidibu};
  my $rdt = $reflay->{defitexto} = {}; 
  my $rde = $reflay->{defiele}; #en definir_dibu se lleno ->{datospcs} y .... 
  my $rden = $rde->{nombre} = {};
  my %todos = %{$reflay->{refvalores}->{USO_DEF}};
  foreach my $numobj (keys %todos) {
      my $cuadro = descripcion_cuadro($numobj);
      my $rdtj = $rdt->{$numobj} = {};
      #tiene #nuomj delante del número de objeto del cuadro    
      my @renglones = @{$todos{$numobj}};
      map (do{ s/^\s*//; s/\s*$//; $_ = uc($_)},@renglones);
      #impr_debug(__LINE__.' Elem @renglones ',Dumper \@renglones);
      my %renglonguardado;
      foreach my $palabra ('nombre', 'codigos', 'condicion'
                          , 'parnombrearchivotabla'
                          , 'otrosnodos','funcionesdenodos') {
          $rdtj->{$palabra} = []; 
           
          map (do {/^\s*$palabra\s*(\W.*)$/i and  
                    $renglonguardado{$_} = 1 and 
                    push @{$rdtj->{$palabra}},$1}, @renglones);  
          map ( s/\s*=\s*//,@{$rdtj->{$palabra}}); 
          map (do { /\S/ or 
                   do {porparar1(19,$reflay->{refcirc},
                   "Definición incompleta  para $palabra
                    en $cuadro");  return 19; }  
                  },@{$rdtj->{$palabra}} );
          #impr_debug(__LINE__.' Elem '.$palabra, $rdtj->{$palabra});
      };
      my $nombre;
      if (@{$rdtj->{nombre}} == 1) {
           $nombre = uc($rdtj->{nombre}->[0]);
           $nombre =~ s/^nombre\W+(.+)$/$1/i;
           $rdtj->{nombre} = $nombre; 
      } else {
          porparar1(20,$reflay->{refcirc}
           , "Error en asignación de nombre del elemento en\n   $cuadro
            Cantidad de asignaciones de nombres @{$rdtj->{nombre}}");
          return 20;
      };
      #impr_debug(__LINE__.' Elem defitexto', Dumper $rdtj);
      @renglones = grep (do{not $renglonguardado{$_}}, @renglones);  
      #impr_debug(__LINE__.' Elem @renglones',Dumper \@renglones)
      map (s/\s+//g,@renglones); @renglones = grep(/\S/, @renglones);
      my (@renglonesuso,@renglonesdef);
      if (@renglones) {
          my @malos = grep (/&/, @renglones);
          @malos and 
          do {porparar1(21,$reflay
              ,"No deben aparecer símbolos & en\n   $cuadro");
              return 21;
          };
          my $renglon = shift @renglones;
          while ($renglon !~ /^=\s*\>\s*\{(.*)\}/ and @renglones) {
              $renglon  .=  '&' . shift @renglones;
          };
	  #impr_debug(__LINE__.' Elem $renglon', $renglon);
          if (my ($antes,$despues,$malo) 
                = ($renglon =~/^(.+)=\s*\>[\s&]*\{(.*)\}(.*)$/)) {
              @renglonesuso = split /\s*&\s*/, $antes;
              @renglonesdef = split /\s*&\s*/, $despues; 
              unshift @renglones, $malo if $malo;         
          } else {
              porparar1(22,$reflay
              , "Error de sintaxis: no aparece CODIGOS ni separadores  =>{ y }
              en $cuadro" ); 
              return 22;
          };
          @renglones and
          do {porparar1(23,$reflay,"Hay texto luego del separador final }
              en $cuadro");
	      return 23;
          };
          push @renglonesdef, @renglones;
          @renglonesdef  = grep (/\S/,@renglonesdef);
          @renglonesuso  = grep (/\S/,@renglonesuso);
          my $todosren =  "@renglonesuso @renglonesdef";
          $todosren  =~ /[\{\}]/ and
          do {porparar1(24,$reflay, "Error de sintaxis en\n    $cuadro
              Hay llaves de más"  ); 
              return 24;
          };
          if (@renglonesuso) {
              @renglonesuso = juntar_por_signos_y_paren('',@renglonesuso);
              if (@renglonesuso == 1) {
                  my $renglon = $renglonesuso[0];
                  $renglon =~ s/\s+//g; 
                  if ($renglon =~ /^($codelems\w+)\s*=.+/) {
                      $rdtj->{uso} = $renglon;
                  } else {
                      porparar1(25,$reflay
                      ,"Errores de sintaxis en parte de USO en\n    $cuadro");
                      return 25;
                  };
              } else { 
                  my $renguso = join "\n       ", @renglonesuso;
                  porparar1(26,$reflay,"Parte de USO sin renglones o 
                  con más de un renglon en\n     $cuadro:\n       $renguso");
                  return 26;
              };         
          };
      };
      if (@renglonesuso  and @{$rdtj->{codigos}}) {
          porparar1(27,$reflay,"$cuadro tiene
          información mezclada para tierra y no tierra");
          return 27;   
      } elsif (@{$rdtj->{codigos}}) {
	  #impr_debug(__LINE__.' Elem defitexto', Dumper $rdt);
          my $coderr 
              = definir_formula_texto_t($reflay, $nombre, $numobj);
          $coderr and return $coderr;
          next;
      }; 
      defined $rdtj->{uso} or 
      do {porparar1(28,$reflay
          ,"Sin CODIGOS ni parte de USO, o errores de syntasis en
           $cuadro"); 
          return 28;
      }; 
      if (@renglonesdef) {
          @renglonesdef = juntar_por_signos_y_paren('',@renglonesdef);
          map (s/\s+//g,@renglonesdef);  
          $rdtj->{definicion} = \@renglonesdef; 
      } else {
          porparar1(29,$reflay,"Sin parte de DEF en\n    $cuadro"); 
          return 29;
      };
 
      #impr_debug(__LINE__.' Elem defitexto', Dumper $rdtj);
      my $coderr; 
      $coderr   = definir_formula_texto($reflay, $nombre, $numobj);
      $coderr and return $coderr; 
      #impr_debug(__LINE__.' Elem defitexto', Dumper $rdtj);
  }# foreach  my $numobj ;
  #impr_debug(__LINE__.' Elem defidibu',   Dumper $rdb);
  #impr_debug(__LINE__.' Elem defitexto',   Dumper $rdt);
  #impr_debug(__LINE__.' Elem defiele',   Dumper $rde);
  foreach my $nombre (keys %$rden) {
      my $rdenn = $rde->{nombre}->{$nombre};
      my $clasepcs = $rdenn->{clasepcs};
      $rde->{datosclasepcs}->{$clasepcs}->{nombre} = $nombre;
      foreach my $palabra ('cod', 'codvalor', 'otrosnodos') {
          my @lista = union_conjunto(@{$rdenn->{$palabra}}); 
          if (@lista == 1) {
              $rde->{datosclasepcs}->{$clasepcs}->{$palabra}
                = $lista[0];
              delete $rdenn->{$palabra};
          } else {
              porparar1(66,$reflay);
              return 66;
          };    
      };
  };
  #impr_debug(__LINE__.' Elem defiele',   Dumper $rde);
  foreach my $texto (keys %$rdb) {
      my $rdbt = $rdb->{$texto};   
      defined $rdbt->{numobj} or
      do {porparar1(30,$reflay,"No hay ningún cuadro USO_DEF para
       íconos identificados con \"$texto\"; lugares: $rdbt->{stringlugares}"); 
          return 30;
      };
      @{$rdbt->{numobj}} == 1 or 
      do {porparar1(31,$reflay,"Hay más de un cuadro USO_DEF con 
           texto identificatorio para los elementos \"$texto\"");
          return 31;        
      };
      my $numobj = $rdbt->{numobj} = $rdbt->{numobj}->[0];
  #impr_debug(__LINE__.' Elem defiele',   Dumper $rde);
  #impr_debug(__LINE__.' Elem defitexto',   Dumper $rdt);
      my $nombre = $rdt->{$numobj}->{nombre};       
      #a varios $textos puede corresponder igual nombre
      defined $rde->{nombre}->{$nombre} or  $rde->{nombre}->{$nombre} = {};
  }; 
  #impr_debug(__LINE__.' Elem defidibu',   Dumper $rdb);
  comfin('fin definir_texto');
  return '';
} 
# ----------------------------------------------------------------------------
sub definir_formula_texto_t{
  #es llamada por definir_texto y llama a mirar_NODOS
  comfin('comfin definir_formula_texto_t',@_);
  my ($reflay, $nombre,$numobj) = @_;
  my $cuadro = descripcion_cuadro($numobj);
  #impr_debug(__LINE__.' Elem defiele', Dumper $reflay->{defiele});
  #impr_debug(__LINE__.' Elem defitexto', Dumper $reflay->{defidibu});
  my ($rdb, $rdt,$rde)  = @$reflay{'defidibu', 'defitexto','defiele'};
  #impr_debug(__LINE__.' Elem $rdb', Dumper $rdb);
  my $rdtj = $rdt->{$numobj};
  my $rden = $rde->{nombre};
  defined $rden->{$nombre} or 
  do {$rden->{$nombre} = {}; 
      $rden->{$nombre}->{formula} = {};
  };
  my $rdenn = $rden->{$nombre}; my $rdennf = $rdenn->{formula};
  #impr_debug(__LINE__.' Elem defitexto->{$numobj', Dumper $rdtj);
  if (@{$rdtj->{codigos}} == 1) { 
      if ($rdtj->{codigos}->[0] =~ /^(\S)\s*(\S)/i) { 
 	  $rdtj->{codigos} = [$1,$2]; 
          my $formula = uc($2).'0';
          my $texto = '0';

          my $rdbt = $rdb->{$texto};
          not defined $rdbt and
	  do {porparar1(40,$reflay
              ,"No hay ningún ícono posible para tierra;
                no debe admitir identificacion;
               definición inútil en ". descripcion_cuadro($numobj));
               return 40;
          }; 

          $rdtj->{texto} = $texto;
          push @{$rdb->{$texto}->{numobj}}, $numobj;
          my $clasepcs = $rdbt->{clasepcs};
          push @{$rdenn->{cod}}, lc($1);
          push @{$rdenn->{codvalor}}, uc($2); 

          defined  $rdennf->{$formula} and   
          do {porparar1(41,$reflay,
              "Más de una definición para la fórmula $formula,
              para $nombre, en este mismo archivo $CORTOA");
              return 41;
          };
          my $rdennff = $rdennf->{$formula} = {};
          $rdennff->{archivoele} 
             = $reflay->{refcirc}->{archivo};#"$BASEARCHA$PROPIOA"; 
          $rdennff->{comodin} = lc($1).'0';

	  my $coderr = '';my $nodosot;
          $coderr 
             = mirar_NODOS($reflay, $nombre, $formula,'0',$numobj);#para t
          return $coderr;
      };
  } else {
      porparar1(36,$reflay,"Más de un sentencia CODIGOS en\n    $cuadro");
      return 36;
  };
} # definir_formula_texto_t
# ----------------------------------------------------------------------------
sub definir_formula_texto{
  #es llamada por definir_texto y llama a mirar_NODOS
  comfin('com definir_formula_texto',@_);
  my ($reflay,$nombre,$numobj) = @_;
  #impr_debug(__LINE__.' Elem defidibu ', Dumper $reflay->{defidibu});
  #impr_debug(__LINE__.' Elem defitexto ', Dumper $reflay->{defitexto});
  #impr_debug(__LINE__.' Elem defiele ', Dumper $reflay->{defiele});
  my ($rdb, $rdt, $rde)  = @$reflay{'defidibu', 'defitexto','defiele'};
  my $rdtj = $rdt->{$numobj};
  defined $rde->{nombre}->{$nombre} or
  do {$rde->{nombre}->{$nombre} = {}; 
      $rde->{nombre}->{$nombre}->{formula} = {};
  };
  my $rdenn = $rde->{nombre}->{$nombre};

  my ($cod, $texto, $codvalor, $codvalortexto, $listaarg
      , $uso, $comodin,$formula);
  #cada numobj tiene un solo uso, y en consecuencia un solo
  #cod, codvalor, texto, $formula

  $uso = uc($rdtj->{uso}); 
  if (($cod, $texto, $codvalor, $codvalortexto, $listaarg) 
        = $uso =~ /\s*(.)(\S+)\s*=\s*(.)(\w+),\s*(.*\S)\s*$/) {   
  };
  $formula = $3.$4; $comodin = $cod.$texto;
  #se conrola luego que no hay mas que numobj por cada $texto;
  # y como consecuencia habra un solo nombre,cod,codvalor  
  my $rdbt = $rdb->{$texto};
  not defined $rdbt and
  do{ porparar1(40, $reflay,"No hay ningún ícono identificado con $texto;
                definición inútil en ". descripcion_cuadro($numobj));
      return 40;
  }; 
  $rdtj->{texto} = $texto;
  push @{$rdbt->{numobj}}, $numobj; #deberá haber uno solo; 
  my $clasepcs = $rdbt->{clasepcs};
  push @{$rdenn->{cod}},  $cod;
  push @{$rdenn->{codvalor}}, $codvalor;

  #@{$rde->{datosclasepcs}->{$clasepcs}}{'cod', 'codvalor', 'nombre'}
  #  = ($cod, $codvalor, $nombre);
  #impr_debug(__LINE__.' Elem rdnn', Dumper $rdenn);
  #impr_debug(__LINE__.' Elem rdb->{$texto}', Dumper $rdbt);

  #@{$rdenn}{'cod', 'codvalor', 'cuantosnodos', 'plantilla'}
  # = @{$rdbt}{'cod', 'codvalor', 'cuantosnodos', 'plantilla'};
  defined $rdenn->{formula}->{$formula} and
  do{ porparar1(41,$reflay, "Más de una definición para la fórmula $formula,
      para $nombre, en este mismo archivo $CORTOA"); 
      return 41;
  }; 
  my $rdennff = $rdenn->{formula}->{$formula} = {}; 
  
  $rdennff->{uso} = $uso;
  $rdennff->{archivoele} = $reflay->{refcirc}->{archivo};#"$BASEARCHA$PROPIOA";
  $rdennff->{comodin} = $comodin;
  $rdennff->{condicion} = $rdtj->{condicion};
  #$rdennff->{nodos} = $rdbt->{nodos}; 
  my @listaarg = split /\s*,\s*/, $listaarg;
  my @listaexp = grep(/\S/,@listaarg);
  (scalar (union_conjunto(@listaexp))  != scalar (@listaarg))  and
  do {porparar1(42,$reflay
       ,"Hay argumentos repetidos o vacíos:\n      @listaarg\n   en " .
        descripcion_cuadro($numobj)); 
       return 42; 
  };
#  $rdennff->{listaarg} =\@listaarg;           
#  $rdennff->{listaPARAMETROS} =[]; $rdennff->{listaDATOS} = [];
  #impr_debug(__LINE__.' Elem defitexto ', Dumper $reflay->{defitexto});
  #impr_debug(__LINE__.' Elem defiele ', Dumper $reflay->{defiele});
  #impr_debug(__LINE__.' Elem defidibu ', Dumper $reflay->{defidibu});

  my $coderr = mirar_NODOS($reflay, $nombre, $formula, $texto, $numobj);
  #impr_debug(__LINE__.' Elem defiele ', Dumper $reflay->{defiele});
  #impr_debug(__LINE__.' Elem defitexto ', Dumper $reflay->{defitexto});
  $coderr and return $coderr;
  $rdennff->{definicion} = $rdtj->{definicion};
  $rdennff->{funcionesdenodos} = $rdtj->{funcionesdenodos} 
      if defined $rdtj->{funcionesdenodos};        
  $rdennff->{parnombrearchivotabla} = $rdtj->{parnombrearchivotabla} 
      if defined $rdtj->{parnombrearchivotabla};        
  my @listaPARAMETROS;
  foreach my $renglon (@{$rdennff->{definicion}}) {
      $renglon =~ s/\s+//g;          
      if ($renglon =~  /^(\w)(\w*)=(\S+)$/) {
          if ($1 eq 'P') {
              $rdennff->{PARAMETROS}->{"$1$2"} = $3;
              push @listaPARAMETROS, "$1$2";
          } else {
              $rdennff->{DATOS}->{"$1$2"} = $3;
              push @{$rdennff->{listaDATOS}}, "$1$2";
          };
      } else {
          porparar1(43,$reflay
            ,"Error de siintaxis (no es asignación) en el renglón
            $renglon de la definición para $comodin");
          return 43;
      };
  }; 
  scalar @listaarg + scalar @listaPARAMETROS == 
     scalar union_conjunto(@listaarg,@listaPARAMETROS) or
  do {porparar1(44, $reflay
      ,"No debe haber argumentos y parámetros de igual nombre
      argumentos: @listaPARAMETROS
      parámetros: @listaarg");
      return 44;
  };
  $rdennff->{listaarg} = \@listaarg;  
  $rdennff->{listaPARAMETROS} = \@listaPARAMETROS;;
  @{$rdennff->{listaDATOS}} == 1 and $rdennff->{listaDATOS}->[0] eq $comodin or
  do {porparar1(44,$reflay
        ,"Error de sintaxis en la definición para $comodin;
        no asigna a $comodin sino  a: @{$rdennff->{listaDATOS}} ");
      return 44;
  };
  $coderr =  mirar_CONDICION($reflay, $nombre, $formula) 
                  if @{$rdennff->{condicion}};
  $coderr and return $coderr;

  #impr_debug(__LINE__.' Elem defidibu', Dumper $rdb);
  #impr_debug(__LINE__.' Elem defitexto', Dumper $rdt);
  #impr_debug(__LINE__.' Elem defiele ', Dumper $rde);
  comfin('fin definir_formula_texto');
  return '';
} 
# ----------------------------------------------------------------------------
sub mirar_NODOS{
  comfin('com? mirar_NODOS', @_);
  my ($reflay, $nombre, $formula,$texto,$numobj) = @_;
  my ($rdb, $rdt, $rde) = @$reflay{'defidibu', 'defitexto', 'defiele'}; 
  my ($rden, $rdenn) = ($rde->{nombre},$rde->{nombre}->{$nombre});
  my $rdennff = $rdenn->{formula}->{$formula};
  #impr_debug(__LINE__.' Elem defitexto comienzo mirar_NODOS'
  #    ,Dumper $rdt);
  #impr_debug(__LINE__.' Elem defiele comienzo mirar_NODOS'
  #    ,Dumper $rde);
  #impr_debug(__LINE__.' Elem defidibu comienzo mirar_NODOS'
  #    ,Dumper $rdb);
  my $clasepcs = $rdb->{$texto}->{clasepcs};
  $rdenn->{clasepcs} = $clasepcs;
  my $comodin = $rdennff->{comodin};
  $rdennff->{uni}->{$comodin} = $rdb->{$texto}->{nodos} 
      if $rdb->{$texto}->{nodos};
  
  #my @lista = @{$rdt->{$numobj}->{nodos}};

   #my @OTROS = grep (/^otrosnodos/i,@lista);
  my @OTROS = @{$rdt->{$numobj}->{otrosnodos}};
  my $cod = $rdenn->{cod}->[-1];#si hay mas de uno se detecta luego el error
  my $nodosot;
  my $cuantosnodos 
     = $rde->{datosclasepcs}->{$clasepcs}->{cuantosnodos}; 
  if (@OTROS >1) {
      porparar1(45,$reflay, 'Hay ' . scalar @OTROS
               .' > 1 renglones con otrosnodos');
      return 45;
  } elsif (@OTROS) {
      my $renglonnodos = $OTROS[0];
      if ($renglonnodos =~ /^\s*(.+)/i) { 
          $nodosot = $1;
          $nodosot =~ s/\s+//g;
          push @{$rdenn->{otrosnodos}}, $nodosot;
          my $preg= ($nodosot =~ tr/?//);
          my $cuantosot = ($nodosot =~ tr/\-//) +1;
          if ($preg >1) {
              porparar1(46,$reflay
              ,"Más de un signo ? en OTROSNODOS = $nodosot"); 
              return 46;
          } elsif ($cuantosot != 2 and $cod =~ /[CEJLR]/) {          
              porparar1(47,$reflay,descripcion_cuadro($numobj) 
                  . " indica,con OTROSNODOS número distinto de dos conexiones
                      para el elemento identificado con $texto");
              return 47;
          } elsif ($preg == 1 and defined $rdenn->{cuantosnodos}) {      
              if ($cuantosnodos != 1 and $cod =~ /[CEJLR]/) { 
                  porparar1(48,$reflay,"Inconsistencia entre parte grafica y 
                  textual sobre cantidad de conexiones");
                  return 48;
              };
          };
      } else {
          #$rdb->{$texto}->{otrosnodos} = '';
          push @{$rdenn->{otrosnodos}}, '';
          if (not defined $cuantosnodos and  $cod ne 't') {
              porparar1(49,$reflay,"Elemento identificado con $texto, 
              sin conexiones, pero no declarado con código \"t\"");
              return 49; 
          } elsif ($cuantosnodos != 2 and $cod =~ /[CEJLR]/) { 
              porrparar1(50,$reflay,"Cantidad de conexiones, $cuantosnodos,
              incorrecta para los íconos, de clase $cod,
              identificados con $texto"); 
              return 50;  
	  };
      };
  } else {
          push @{$rdenn->{otrosnodos}}, '';
  };
  #@lista = grep (/^funcionesdenodos/i,@lista); #en mirar_NODOS
  my $reflista = $rdt->{$numobj}->{funcionesdenodos};
  #impr_debug(__LINE__.' Elem ',Dumper $reflista );
  if (defined $reflista and @{$reflista}) {
      my @lista = @$reflista;
      #map (s/^funcionesdenodos\s*//i, @lista);
      #map (s/^=\s*//, @lista);
      @{$rdennff->{funcionesdenodos}} = @lista;
      @lista = union_conjunto(@lista); my %usado;
      my $defin = $rdt->{$numobj}->{definicion}; my $mal = '';
      my @nonodos;
      #impr_debug(__LINE__.' Elem ', $defin); 
      foreach (@$defin) {
          my ($izq,$der) = /^(\w+)=(.+)$/; $der = ";$der;";
          foreach my $func (@lista) {
	      #impr_debug(__LINE__.' Elem $der', $der); 
              while ($der =~ s/(\W$func\()(\w+)\)/$1&NODOELEM$2\)/) {
                  $usado{$func} = 1;
                  push @{$rdt->{$numobj}->{NODOELEM}},$2;
                  push @{$rdennff->{nodoelem}},$2;
                  $rdb->{$texto}->{esunnodo}->{$2} or
		  push @nonodos, $2;
              };
              if ($der =~ /\W$func(\W)/ and $1 ne '(') {
                  $mal = 1;
              };  
                 
          };
          $der =~ s/&//g; 
          $der =~ s/^;(.*);$/$1/;
          $_ = "$izq=$der";
      };
      @nonodos and 
      do {porparar1(51, $reflay
         , "@nonodos debieran ser nodos y no lo son");
          return 51; 
      };            

      #impr_debug(__LINE__.' Elem %usado', Dumper \%usado);
      #impr_debug(__LINE__.' Elem @lista', Dumper \@lista);
      scalar keys %usado == @lista and not $mal  or
      do {avnograv("Hay funcionesdenodos (@lista) no usadas (o no bien usadas)
                 en USO_DEF de $nombre");  
      };
      $rdt->{definicion} = $defin;
  } else {
      $rdennff->{funcionesdenodos} = [];
  }
  #impr_debug(__LINE__.' Elem defiele',Dumper $rde);
  comfin('fin mirar_NODOS');
  return '';  
}  
# ----------------------------------------------------------------------------
sub mirar_CONDICION{
  comfin('com mirar_CONDICION', @_);
  my ($reflay, $nombre, $formula) = @_;
  my $rdennff = $reflay->{defiele}->{nombre}->{$nombre}->{formula}->{$formula};
  #impr_debug(__LINE__.' Elem $rdennff condicion'
  #      , Dumper $rdennff->{condicion});
  #cada condicion (numerada)  puede ser un or ||  de varias otras and &
  #no admito parentesis
  map (s/CONDICION\s*=\s*//i,@{$rdennff->{condicion}});
  map (s/CONDICION//i, @{$rdennff->{condicion}});
  my @listacond = @{$rdennff->{condicion}}; 
  my $stringcond = "@listacond";
  $stringcond =~ /[\(\)\+\-\*\/]/ and
      do {$stringcond = join "\n       ", @listacond;
porparar1(55,$reflay
       ,"No se admiten paréntesis ni operaciones aritméticas en 
         las condiciones\n       $stringcond");
        return 55;
  }; 
  foreach my $cond (@listacond) {
      my $resul = eval($cond);
      my @listaor = split /\s*\|\|\s*/, $cond;
      #impr_debug(__LINE__.' Elem $cond',[$cond,$resul]);
      foreach my $expror (@listaor) {
          my @listaand = split /\s*&\s*/, $expror;
          my $resul = eval($expror);
          #impr_debug(__LINE__.' Elem   $expror',[$expror,$resul])
          #    if @listaor >1;
          foreach my $compa (@listaand) {
              my ($pal1,$op,$pal2,);
              my $resul = eval($compa);
              #impr_debug(__LINE__.' Elem      $compa',[$compa,$resul]);
              if(($pal1,$op,$pal2) = ($compa =~ /\s*(\w+)(\W+)(\w+)/)) {
                  foreach my $var ($pal1,$pal2) {
                      my($tipo,$nvalor) = tipear($rdennff,$var,0);
		      $rdennff->{varcond}->{$var}= 1  if ($tipo ne 'n')
                  }; 
              } else {
                  porparar1(56,$reflay,"En  $cond para $nombre
                  no se entiende $compa ; deberia ser una comparación"); 
		  return 56;
              };

          };
      };
  };
  my $stringlistaarg = ';'. join (',',@{$rdennff->{listaarg}}) .';';
  foreach my $var (keys %{$rdennff->{varcond}}) {
      if ($stringlistaarg =~ /\W$var\W/) {
          $rdennff->{varcond}->{$var} = 'arg'; 
      } elsif (defined $rdennff->{PARAMETROS}->{$var}) {   
          $rdennff->{varcond}->{$var} = 'PARAMETROS';
      } else { 
          porparar1(57,$reflay, "En las condiciones:\n"
          . join("/n",@listacond)
		    .    "no se reconoce $var");
          return 57;
      };
  };
  #impr_debug(__LINE__.' Elem varcond', Dumper $rdennff->{varcond});  
  #impr_debug(__LINE__.' Elem',Dumper $rdennff); 
  comfin('fin mirar_CONDICION');
  return '';
}  
# ---------------------------------------------------------------------------
sub asignar_defiele{
  comfin('com asignar_defiele', @_);
  #hace lo que puede por asignar; no interrumpe  a todo simusol por errores
  #pero si interrumpe procesamiento de la capa; es decir 
  #no tiene en cuenta definiciones correctas junto con incorrectas
  #interpreta las definiciones de los diferentes tipos de objetos
  my ($reflay) = @_; 
  my ($rdb,$rde) = @$reflay{'defidibu', 'defiele'};
  #impr_debug(__LINE__. 'Elem $rde', Dumper $rde);
  my $rden = $rde->{nombre};
  my $listaformulas;
  foreach my $nombre (keys %$rden) {
      my $rdenn = $rden->{$nombre};
      my $clase = $rdenn->{clasepcs};
      foreach my $formula (keys %{$rdenn->{formula}}) {
          my $rdennff= $rdenn->{formula}->{$formula};
          next unless defined $rdennff->{definicion};
          my $comodin = $rdennff->{comodin};
          my $lisque =  ['DATOS','PARAMETROS'];
          my $coderr = normalizar($rdennff, $lisque); #en asignar_defiele
          not $coderr and 
          $coderr = limpiar_unico($rdennff, $lisque); #asignar_defiele
          $coderr and return $coderr;  
          my @varposibles;
          if (@{$rdennff->{listaPARAMETROS}}) {
              #push @varposibles, keys %{$ref->{PARAMETROS}};
              $coderr = controlar_cadena_param($rdennff);
              $coderr and return $coderr;
          };
          push @varposibles, @{$rdennff->{listaarg}} 
              if defined $rdennff->{listaarg};
          if ($comodin !~ /^E/) {push @varposibles,"V$comodin"};
          if ($comodin !~ /^J/) {push @varposibles,"I$comodin"}; 
          my %posibles;
          map($posibles{$_} = 1, @varposibles);
          my @lisexpres = ();
          push @lisexpres,$rdennff->{DATOS}->{$comodin}; 
          push @lisexpres, values %{$rdennff->{PARAMETROS}} 
             if defined $rdennff->{PARAMETROS};
          my $reflistafunnod = $rdennff->{funcionesdenodos};
          #ya mirar_NODOS  controlo que los argumentos de las 
          #FUNCIONESDENODS sean efectivamente nodos y están marcados
          #como NODOELEM; ahora sustituimos provisoriamente por 1
          #para que no aparezcan contabilizadas como funciones y/ o variables
          #impr_debug(__LINE__.' Elem   lisexpres ',\@lisexpres);
          my $expresion = ';' . join (';',@lisexpres) . ';';
          #para que no se vean las llamadas a FUNCIONESDENODOS
          my $uno = 1;
          foreach my $fun (@{$rdennff->{funcionesdenodos}}) {
              while ($expresion =~ s/(\W)$fun\(\w+\)(\W)/$1$uno$2/) {}
          };
          #impr_debug(__LINE__.' Elem %posibles',Dumper \%posibles);
          my ($coderror,$reff,$refp,$reft,$refv,$refx,$refnodo) 
            = fun_par_tab_var($expresion,$rdennff,\%posibles); #en as_defiele
          #impr_debug(__LINE__.' Elem $refv',Dumper $refv);
          #impr_debug(__LINE__.' Elem $refp',Dumper $refp);
          $coderror and return $coderror;
          my @noposibles; 
          #impr_debug(__LINE__.' Elem', Dumper $refv); 
          #impr_debug(__LINE__.' Elem @noposibles', Dumper \@noposibles); 
          foreach (keys %$refv) {
              #impr_debug(__LINE__.' Elem   ',$_);
              next if $posibles{$_};
              push @noposibles, $_;
          };
          @noposibles and 
	  do {foreach my $nodo (@noposibles) {
                  if ($reflay->{refcirc}->{cualobjtextonodo}) {
                      explic("Quizas necesita declarar FUNCIONESDENODOS");
		      last;
		  };
              }; 
              porparar1(60,$reflay,"Variables no posibles @noposibles");
              return 60;
          };
          push @{$listaformulas->{$nombre}}, $formula;
          # se deja que el que programe las formulas elija bien que explotar
          # si no, se demora hasta que se sustituye 
          $coderr and return $coderr;
      }; # my $formula
  }; # my $nombre
  #impr_debug(__LINE__. 'Elem $rde', Dumper $rde);
  comfin('fin asignar_defiele');
  return '';
}
# ---------------------------------------------------------------------------
sub asignar_ele{
  comfin('com asignar_ele', @_);
# incorpora a $DEFIELE la información de $defiele que no choca con la anterior
  my $reflay = $_[0];
  my $rde = $reflay->{defiele};
  my $usado = '';  
  foreach my $pcs (keys %{$rde->{datospcs}}) {
      if (defined $DEFIELE->{datospcs}->{$pcs}) { 
          my $Clase = $DEFIELE->{datospcs}->{$pcs}->{clasepcs};
          my $clase = $rde->{datospcs}->{$pcs}->{clasepcs}; 
          $Clase eq  $clase or  
	  do {porparar1(66,$reflay, "$pcs está agrupado en forma diferente;
              antes: $Clase    ahora: $clase;
              se ignorarán las definiciones del archivo 
              $CORTOA");;
              return 66;
          };
      } else {
	  $DEFIELE->{datospcs}->{$pcs}->{clasepcs} 
             = $rde->{datospcs}->{$pcs}->{clasepcs}; 
      };
  };
  foreach my $clasepcs (keys %{$rde->{datosclasepcs}}) {
      if (not defined $DEFIELE->{datosclasepcs}->{$clasepcs}) {
          $usado = 1;
          my $rdecc = $rde->{datosclasepcs}->{$clasepcs};
          %{$DEFIELE->{datosclasepcs}->{$clasepcs}} 
              = %{$rdecc};
          my $nombre = $rdecc->{nombre};
          %{$DEFIELE->{nombre}->{$nombre}} 
             =  %{$rde->{nombre}->{$nombre}}; 
          my @listapcs = split ' ', $clasepcs;
          foreach my $pcs (@listapcs) {
              $comocod->{$pcs} = $rdecc->{cod};
	      $comocodvalor->{$pcs} = $rdecc->{codvalor}; 
              $comootrosnodos ->{$pcs} = $rdecc->{otrosnodos};
              $comonombre ->{$pcs} = $rdecc->{nombre};
          };  
      } else {
	  #impr_debug(__LINE__.' Elem $clasepcs '.$clasepcs
	  #	     , Dumper $DEFIELE->{datosclasepcs}->{$clasepcs});
          my $nombre = $rde->{datosclasepcs}->{$clasepcs}->{nombre};
          my $Nombre =
                $DEFIELE->{datosclasepcs}->{$clasepcs}->{nombre};
          $Nombre eq $nombre or
          do{ explic("$clasepcs tiene nombres diferentes;
              antes: $Nombre   ahora: $nombre; 
              se ignorarán las nuevas definiciones");
              next;
          };
          my $rdenn = $rde->{nombre}->{$nombre};
          my $rDenn = $DEFIELE->{nombre}->{$nombre};
          foreach my $formula (keys %{$rdenn->{formula}}) { 
              if (not defined $rDenn ->{formula}->{$formula}) { 
                  $usado = 1;
                  %{$rDenn ->{formula}->{$formula}}
                     = %{$rdenn ->{formula}->{$formula}};
              } else { 
                  explic("Hay definición anterior para la formula $formula;
                          se mantendrá");
              };
          }; 
      };        
  };
  push @{$DEFIELE->{archeleorigen}}, $reflay->{refcirc}->{archivo} if $usado;
  #impr_debug(__LINE__.' Elem $DEFIELE', Dumper  $DEFIELE); 

comfin('fin asignar_ele');

}# asignar_ele 
# ----------------------------------------------------------------------------
1
